// main.cpp
// Statybos irankiu nuoma
#include <iostream>
#include <fstream>
#include <vector>
using namespace std;
//------------------------------------------------------------
struct Tool
{
    string   name;
    int      year;
    int      useEnergy;
    string   format;
    double   dayPrice;
    int      rentedByCustomer;
    double   moneyEarned;
    int      inventorizationNumber;
};
typedef vector<Tool> Tools;
//------------------------------------------------------------
struct Customer
{
    string   name;
    string   lastName;
    string   address;
    string   personalCode;
    double   moneyEarned;
};
typedef vector<Customer> Customers;
//------------------------------------------------------------
void printTools     (const Tools&      tools);
void printCustomers (const Customers&  customers);
void addTool        (      Tools&      tools);
void addCustomer    (      Customers&  customers);
void rentTool       (      Tools&      tools, Customers& customers);
void returnTool     (      Tools&      tools);
void mostPopular    (      Tools&      tools);
//------------------------------------------------------------
int main ()
{
    Tools     tools;
    Customers  customers;
    
    for (;;)
    {
        cout << endl
             << "Statybos irankiu nuoma:"       << endl
             << "  1 - spausdinti irankius"     << endl
             << "  2 - prideti nauja iranki"    << endl
             << endl
             << "  3 - spausdinti klientus"     << endl
             << "  4 - prideti nauja klienta"   << endl
             << endl
             << "  5 - isnuomuoti klientui"     << endl
             << "  6 - irankis grazintas"       << endl
             << "  7 - popiliariausi irankiai"  << endl
             << endl
             << "  0 - baigti darba"            << endl
             << "> ";
        string key;
        getline(cin, key);
             if (key == "0") return 0;
        else if (key == "1") printTools     (tools);
        else if (key == "2") addTool        (tools);
        else if (key == "3") printCustomers (customers);
        else if (key == "4") addCustomer    (customers);
        else if (key == "5") rentTool       (tools, customers);    
        else if (key == "6") returnTool     (tools);
        else if (key == "7") mostPopular    (tools);
        else cout << endl << "Neteisinga komanda..." << endl;   
    }
    
}
//------------------------------------------------------------
void printTools    (const Tools&    tools)
{
    cout << "Irankiu kiekis: " << tools.size() << endl;
    for (int i = 0;  i < tools.size();  i++)
    {
        cout << (i+1)
             << ". "  << tools[i].rentedByCustomer
	     << "\t"   << tools[i].name
         << "\t"   << tools[i].format
	     << "\t"   << tools[i].year
	     << "\t("  << tools[i].inventorizationNumber << ")"
         << "\t"   << tools[i].dayPrice << "Lt"
	     << "\t"   << tools[i].useEnergy << "kW"
         << "\t("  << tools[i].moneyEarned << "Lt)"
             << endl;
    }                  
}
//------------------------------------------------------------
void printCustomers (const Customers& customers)
{
    cout << "Klietu kiekis: " << customers.size() << endl;
    for (int i = 0;  i < customers.size();  i++)
    {
        cout << (i+1)
             << ". ("  << customers[i].moneyEarned << "Lt)"
	         << "\t"   << customers[i].lastName
             << "\t"   << customers[i].name
             << "\t"   << customers[i].address
	         << "\t("  << customers[i].personalCode << ")"
             << endl;
    }
}
//------------------------------------------------------------
void addTool (Tools& tools)
{
    Tool tool;
    cout << "Iveskite nauja iranki:" << endl;
    cout << "   pavadinimas (bosch/irwin)          : ";  getline(cin, tool.name);
    cout << "   irankio tipas (slifuoklis/graztas) : ";  cin >> tool.format;
    cout << "   inventorizacijos numeris           : ";  cin >> tool.inventorizationNumber;
    cout << "   metai                              : ";  cin >> tool.year;
    cout << "   suvartoja energijos                : ";  cin >> tool.useEnergy;
    cout << "   kaina dienai                       : ";  cin >> tool.dayPrice;
    tool.rentedByCustomer =  0;  
    tool.moneyEarned      =  0;
    tools.push_back(tool);   
}
//------------------------------------------------------------
void addCustomer (Customers& customers)
{
    Customer customer;
    cout << "Iveskite nauja klienta:" << endl;
    cout << "   vardas      : ";  getline(cin, customer.name);
    cout << "   pavarde     : ";  getline(cin, customer.lastName);
    cout << "   adresas     : ";  getline(cin, customer.address);
    cout << "   asmens kodas: ";  getline(cin, customer.personalCode);
    customer.moneyEarned = 0;
    customers.push_back(customer);   
}
//------------------------------------------------------------
void rentTool (Tools& tools, Customers& customers)
{
     int toolNo = 0;
     printTools (tools);
     cout << "Iveskit irankio eiles numeri: ";
     cin  >> toolNo;
     if (toolNo <= 0  ||  toolNo > tools.size())
     {
         cout << "KLAIDA: nera irankio su ivestu eiles numeriu.";
         return;
     }
     if (tools[toolNo-1].rentedByCustomer != 0)
     {
         cout << "KLAIDA: irankis jau yra isnuomotas.";
         return;
     }
     
     int customerNo = 0;
     printCustomers (customers);
     cout << "Pasirinkite kliento eiles numeri: ";
     cin  >> customerNo;
     if (customerNo <= 0  ||  customerNo > customers.size())
     {
         cout << "KLAIDA: nera kliento su ivestu eiles numeriu.";
         return;
     }
     
     int dayCount;
     cout << "Keliom dienom nuomuosime        : ";
     cin  >> dayCount;     
     tools[toolNo-1].rentedByCustomer   = customerNo;
     tools[toolNo-1].moneyEarned       += dayCount * tools[toolNo-1].dayPrice;
     customers[customerNo-1].moneyEarned += dayCount * tools[toolNo-1].dayPrice;
}
//------------------------------------------------------------
void returnTool    (Tools&     tools)
{
     int toolNo = 0;
     printTools (tools);
     cout << "Iveskit irankio eiles numeri: ";
     cin  >> toolNo;
     if (toolNo <= 0  ||  toolNo > tools.size())
     {
         cout << "KLAIDA: nera irankio su ivestu eiles numeriu.";
         return;
     }
     tools[toolNo-1].rentedByCustomer = 0;
}
//------------------------------------------------------------
void mostPopular (Tools& tools)//===============================================
{
}
//============================================================
